Index: /trunk/Documents/INSTALL
===================================================================
--- /trunk/Documents/INSTALL	(revision 88)
+++ /trunk/Documents/INSTALL	(revision 88)
@@ -0,0 +1,45 @@
+--------------------------------------------------
+ Table of contents
+--------------------------------------------------
+
+ I   - Install
+
+--------------------------------------------------
+ I   - Install   
+--------------------------------------------------
+
+Follow this step to install the Morpheo Tools Chain
+
+1) Install GNU-Toolchain
+
+cf Tools-source/or1k_toolchain-build-instructions.txt
+
+2) Install newlib
+
+Now you can compile a software and use the libc and libm
+
+3) Install a simulator
+
+3a) systemC
+...
+
+3b) systemCASS
+
+4) Install soclib
+
+...
+
+5) Link
+
+This step consist at create all symbolik link
+ * Morpheo/Tools :
+   - newlib
+   - or1k
+   - soclib
+   - systemc (or systemcass)
+ * Morpheo/Software/*/src/sys/
+   - crt0.s           with $TOOLS/newlib/libgloss/or32/crt0.S
+ * Morpheo/IPs/systemC/shared/
+   - mapping_memory.h
+
+6) Enjoy
Index: /trunk/IPs/systemC/Environment/Cache/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/Cache/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/Cache/Makefile	(revision 88)
@@ -4,4 +4,6 @@
 
 #-----[ Variable ]-----------------------------------------
+
+ENTITY                         ?= Cache
 
 OBJECTS_DEPS			= $(patsubst $(DIR_QUEUE)/$(DIR_SRC)/%.cpp,$(DIR_QUEUE)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_QUEUE)/$(DIR_SRC)/*.cpp))
@@ -19,4 +21,6 @@
 				$(MAKE)                          environment_clean;
 
+clean_all			: clean
+
 help				:
 				@$(MAKE) environment_help
Index: /trunk/IPs/systemC/Environment/Common/include/Debug.h
===================================================================
--- /trunk/IPs/systemC/Environment/Common/include/Debug.h	(revision 87)
+++ /trunk/IPs/systemC/Environment/Common/include/Debug.h	(revision 88)
@@ -3,13 +3,13 @@
 
 #define DEBUG_ENVIRONMENT true
-#define DEBUG_CACHE       false
-#define DEBUG_DATA        false
-#define DEBUG_ENDIANNESS  false
-#define DEBUG_QUEUE       false
-#define DEBUG_RAMLOCK     false
-#define DEBUG_SIM2OS      false
-#define DEBUG_TTY         false
+#define DEBUG_CACHE       true
+#define DEBUG_DATA        true
+#define DEBUG_ENDIANNESS  true
+#define DEBUG_QUEUE       true
+#define DEBUG_RAMLOCK     true
+#define DEBUG_SIM2OS      true
+#define DEBUG_TTY         true
 
-#ifdef DEBUG
+// #ifdef DEBUG
 # define _cout(component, str...)					\
   do									\
@@ -19,11 +19,13 @@
 	  fprintf(stdout,str);						\
 	}								\
-    } while(0)
-#else
-# define _cout(component, str...)					\
-  do									\
-    {									\
-    } while(0)
-#endif
+    } 								        \
+  while(0)
+// #else
+// # define _cout(component, str...)					
+//   do									
+//     {								
+//     }
+//    while(0)
+// #endif
 
 #endif
Index: /trunk/IPs/systemC/Environment/Data/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/Data/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/Data/Makefile	(revision 88)
@@ -4,4 +4,6 @@
 
 #-----[ Variable ]-----------------------------------------
+
+ENTITY                         ?= Data
 
 # OBJECTS_DEPS			= $(patsubst $(DIR_ENDIANNESS)/$(DIR_SRC)/%.cpp,$(DIR_ENDIANNESS)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_ENDIANNESS)/$(DIR_SRC)/*.cpp))
@@ -21,4 +23,6 @@
 # 				$(MAKE) --directory=$(DIR_ENDIANNESS) clean; \
 
+clean_all			: clean
+
 help				:
 				@$(MAKE) environment_help
Index: /trunk/IPs/systemC/Environment/Data/include/Segment.h
===================================================================
--- /trunk/IPs/systemC/Environment/Data/include/Segment.h	(revision 87)
+++ /trunk/IPs/systemC/Environment/Data/include/Segment.h	(revision 88)
@@ -39,4 +39,5 @@
   public : void                 read          (uint32_t address, uint32_t size, char * & data_dest);
   public : void                 write         (uint32_t address, uint32_t size, char * & data_src);
+  public : std::string          print         (uint32_t depth);
   public : friend std::ostream& operator<<    (std::ostream& output, Segment & x);
   };
Index: /trunk/IPs/systemC/Environment/Data/src/Segment_init.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Data/src/Segment_init.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Data/src/Segment_init.cpp	(revision 88)
@@ -1,3 +1,4 @@
 #include "../include/Segment.h"
+#include "../../Common/include/Debug.h"
 
 namespace environment {
@@ -22,6 +23,31 @@
     
     memcpy(data, ptab, size);
-    
+
     free  (ptab);
+      
+
+//     {
+//       _cout(DATA,"Segment Init\n");
+//       _cout(DATA," * size : %d\n",size);
+//       _cout(DATA," * size : %d\n",this->size);
+//       _cout(DATA,"%s\n",print(0).c_str());
+      
+//       uint32_t addr = base;
+//       uint32_t step1 = 4;
+//       uint32_t step2 = step1*8;
+
+//       for (int32_t i=0; i<size; ++i)
+//         {
+//           if ((i%step1) == 0)
+//             _cout(DATA," ");
+//           if ((i%step2) ==0)
+//             {
+//               _cout(DATA,"\n%.8x : ",addr);
+//               addr += step2;
+//             }
+//           _cout(DATA,"%.2x",0xff&static_cast<uint32_t>(data[i]));
+//         }
+//       _cout(DATA,"\n");
+//     }
     
     return true;
Index: /trunk/IPs/systemC/Environment/Data/src/Segment_print.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Data/src/Segment_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Data/src/Segment_print.cpp	(revision 88)
@@ -1,16 +1,28 @@
 #include "../include/Segment.h"
+#include <sstream>
 
 namespace environment {
 namespace data {
+
+  std::string Segment::print(uint32_t depth)
+  {
+    std::ostringstream out("");
+    std::string tab = std::string(depth,'\t');
+
+
+    out << tab << "Segment \"" << name << "\""     << std::endl
+        << std::hex
+        << tab << "  * base     : " << std::setw(8) << std::setfill('0') << base << std::endl
+        << tab << "  * size     : " << std::setw(8) << std::setfill('0') << size << std::endl
+        << std::dec
+        << tab << "  * uncached : " << uncached    << std::endl
+        << tab << "  * type     : " << type;
+
+    return out.str();
+  }
   
   std::ostream& operator<< (std::ostream& output, Segment & x)
   {
-    output << "Segment \"" << x.name << "\""     << std::endl
-	   << std::hex
-	   << "  * base     : " << std::setw(8) << std::setfill('0') << x.base << std::endl
-	   << "  * size     : " << std::setw(8) << std::setfill('0') << x.size << std::endl
-	   << std::dec
-	   << "  * uncached : " << x.uncached    << std::endl
-	   << "  * type     : " << x.type;
+    output << x.print(0);
 	
     return output;
Index: /trunk/IPs/systemC/Environment/Endianness/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/Endianness/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/Endianness/Makefile	(revision 88)
@@ -2,4 +2,6 @@
 
 #-----[ Variable ]-----------------------------------------
+
+ENTITY                         ?= Endianness
 
 #OBJECTS_DEPS			=
@@ -15,4 +17,6 @@
 				$(MAKE) environment_clean;
 
+clean_all			: clean
+
 help				:
 				@$(MAKE) environment_help
Index: /trunk/IPs/systemC/Environment/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/Makefile	(revision 88)
@@ -1,13 +1,18 @@
 #-----[ Directory ]----------------------------------------
 
-DIR_CACHE			= Cache
-DIR_DATA			= Data
-DIR_ENDIANNESS			= Endianness
-DIR_QUEUE			= Queue
-DIR_RAMLOCK			= RamLock
-DIR_SIM2OS			= Sim2OS
-DIR_TTY   			= TTY
+DIR_LIB				= ./lib
+DIR_CACHE			= ./Cache
+DIR_DATA			= ./Data
+DIR_ENDIANNESS			= ./Endianness
+DIR_QUEUE			= ./Queue
+DIR_RAMLOCK			= ./RamLock
+DIR_SIM2OS			= ./Sim2OS
+DIR_TTY   			= ./TTY
 
 #-----[ Variable ]-----------------------------------------
+ENTITY                         ?=	Environment
+
+LIBRARY_NAME			= Environment
+LIBRARY_FILE			= $(DIR_LIB)/lib$(LIBRARY_NAME).a
 
 OBJECTS_DEPS			= 	$(patsubst $(DIR_CACHE)/$(DIR_SRC)/%.cpp,$(DIR_CACHE)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_CACHE)/$(DIR_SRC)/*.cpp))			\
@@ -18,19 +23,64 @@
 					$(patsubst $(DIR_RAMLOCK)/$(DIR_SRC)/%.cpp,$(DIR_RAMLOCK)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_RAMLOCK)/$(DIR_SRC)/*.cpp))		\
 					$(patsubst $(DIR_SIM2OS)/$(DIR_SRC)/%.cpp,$(DIR_SIM2OS)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_SIM2OS)/$(DIR_SRC)/*.cpp)) 		\
-					$(patsubst $(DIR_TTY)/$(DIR_SRC)/%.cpp,$(DIR_TTY)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_TTY)/$(DIR_SRC)/*.cpp))
+					$(patsubst $(DIR_TTY)/$(DIR_SRC)/%.cpp,$(DIR_TTY)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_TTY)/$(DIR_SRC)/*.cpp))			
 
 
 #-----[ Rules ]--------------------------------------------
 
-all				:
+all				: a b c d e f g
 				@\
-				$(MAKE) --directory=$(DIR_CACHE)      all; \
-				$(MAKE) --directory=$(DIR_DATA)       all; \
-				$(MAKE) --directory=$(DIR_ENDIANNESS) all; \
-				$(MAKE) --directory=$(DIR_QUEUE)      all; \
-				$(MAKE) --directory=$(DIR_RAMLOCK)    all; \
-				$(MAKE) --directory=$(DIR_SIM2OS)     all; \
-				$(MAKE) --directory=$(DIR_TTY)        all; \
-				$(MAKE) all_environment;
+				$(MAKE) all_environment; \
+				$(MAKE) $(LIBRARY_FILE);
+
+a				:
+				@\
+				$(MAKE) --directory=$(DIR_CACHE)      all;
+
+b				:
+				@\
+				$(MAKE) --directory=$(DIR_DATA)       all;
+
+c				:
+				@\
+				$(MAKE) --directory=$(DIR_ENDIANNESS) all;
+
+d				:
+				@\
+				$(MAKE) --directory=$(DIR_QUEUE)      all;
+
+e				:
+				@\
+				$(MAKE) --directory=$(DIR_RAMLOCK)    all;
+
+f				:
+				@\
+				$(MAKE) --directory=$(DIR_SIM2OS)     all;
+
+g				:
+				@\
+				$(MAKE) --directory=$(DIR_TTY)        all;
+
+
+$(LIBRARY_FILE)			: $(OBJECTS_DEPS) $(OBJECTS) $(DIR_LIB)
+				@\
+				$(ECHO) "Archive            : $@";\
+				$(AR)  -r $@ $(OBJECTS_DEPS) $(OBJECTS);\
+				$(RANLIB) $@;
+
+$(DIR_LIB)			:
+				@\
+				$(ECHO) "Create directory   : $@";\
+				$(MKDIR) $@;
+
+exe_all				:
+				@\
+				$(MAKE) --directory=$(DIR_CACHE)      exe; \
+				$(MAKE) --directory=$(DIR_DATA)       exe; \
+				$(MAKE) --directory=$(DIR_ENDIANNESS) exe; \
+				$(MAKE) --directory=$(DIR_QUEUE)      exe; \
+				$(MAKE) --directory=$(DIR_RAMLOCK)    exe; \
+				$(MAKE) --directory=$(DIR_SIM2OS)     exe; \
+				$(MAKE) --directory=$(DIR_TTY)        exe; \
+				$(MAKE) exe; \
 
 clean				:
@@ -46,4 +96,7 @@
 				$(RM) tty_*;
 
+clean_all			: clean
+				@\
+				$(RM) $(DIR_LIB);
 
 help				:
Index: /trunk/IPs/systemC/Environment/Makefile.Environment
===================================================================
--- /trunk/IPs/systemC/Environment/Makefile.Environment	(revision 87)
+++ /trunk/IPs/systemC/Environment/Makefile.Environment	(revision 88)
@@ -1,11 +1,18 @@
-include                         $(MORPHEO_TOPLEVEL)/Makefile.tools
-include                         $(MORPHEO_TOPLEVEL)/IPs/systemC/processor/Morpheo/Behavioural/Makefile.flags 
+ifeq ($(origin MORPHEO_TOPLEVEL), undefined)
+	$(error "variable MORPHEO_TOPLEVEL is undefined");
+else
+	include $(MORPHEO_TOPLEVEL)/Makefile.tools
+	include $(MORPHEO_TOPLEVEL)/Makefile.flags
+endif
 
 #-----[ Directory ]----------------------------------------
-DIR_TST                         = selftest
-DIR_INC				= include
-DIR_SRC				= src
-DIR_OBJ				= obj
-DIR_BIN				= bin
+ENTITY                         ?=	Environment
+
+DIR_TMP				=	$(MORPHEO_TMP)/$(ENTITY)
+DIR_TST                         = 	./selftest
+DIR_INC				= 	./include
+DIR_SRC				= 	./src
+DIR_OBJ				= 	./obj
+DIR_BIN				= 	$(DIR_TMP)/bin
 
 #-----[ Compilation ]--------------------------------------
@@ -16,6 +23,7 @@
 LIBDIR 				= $(SYSTEMC_LIBDIR_$(SIMULATOR))
 
-LIBNAME  			= $(SYSTEMC_LIBNAME_$(SIMULATOR)) 	\
-				  -lbfd
+LIBNAME  			= -lbfd                                 \
+                                  -liberty                              \
+                                  $(SYSTEMC_LIBNAME_$(SIMULATOR)) 
 
 FLAGS				= $(SYSTEMC_CFLAGS_$(SIMULATOR))
@@ -26,6 +34,4 @@
 
 #-----[ Variable ]-----------------------------------------
-
-ENTITY				= `$(BASENAME) $$PWD`
 
 OBJECTS				= $(patsubst $(DIR_SRC)/%.cpp,$(DIR_OBJ)/%.o,$(wildcard $(DIR_SRC)/*.cpp)) \
@@ -42,4 +48,9 @@
 #-----[ Rules ]--------------------------------------------
 
+vpath	%.h	$(DIR_INC)
+vpath	%.c	$(DIR_SRC)
+vpath	%.cpp	$(DIR_SRC):$(DIR_TST)
+vpath	%.o	$(DIR_OBJ)
+
 .PRECIOUS			: $(DIR_OBJ)/%.o $(DIR_BIN)/%.x
 
@@ -48,18 +59,13 @@
 				$(ECHO) "-------------------| $(ENTITY)"
 
-$(DIR_OBJ)/%.o			: $(DIR_SRC)/%.cpp $(HEADERS)
+$(DIR_OBJ)/%.o			: %.cpp $(HEADERS)
 				@\
 				$(ECHO) "Compilation        : $*";\
 				$(CXX) $(MORPHEO_CXX_FLAGS) -c -o $@ $<;
 
-$(DIR_OBJ)/%.o			: $(DIR_SRC)/%.c $(HEADERS)
+$(DIR_OBJ)/%.o			: %.c $(HEADERS)
 				@\
 				$(ECHO) "Compilation        : $*";\
 				$(CC)  $(MORPHEO_CC_FLAGS)  -c -o $@ $<;
-
-$(DIR_OBJ)/%.o			: $(DIR_TST)/%.cpp $(HEADERS)
-				@\
-				$(ECHO) "Compilation        : $*";\
-				$(CXX) $(MORPHEO_CXX_FLAGS) -c -o $@ $<;
 
 $(DIR_BIN)/%.x			: $(OBJECTS_DEPS) $(OBJECTS) $(OBJECTS_BIN)
@@ -79,12 +85,13 @@
 
 
-exe				: all
+exe				: all $(DIR_BIN)
 				@\
-				export SYSTEMC=$(SYSTEMC_$(SIMULATOR)) ; $(EXEC_PREFIX) ./$(EXE) $(SYSTEMC_EXEC_PARAMS_$(SIMULATOR))
+				$(MAKE) $(EXE); \
+				export SYSTEMC=$(SYSTEMC_$(SIMULATOR)) ; $(EXEC_PREFIX) $(EXE) $(SYSTEMC_EXEC_PARAMS_$(SIMULATOR))
 
 
-all_environment			: test_env $(DIR_OBJ) $(DIR_BIN)
+all_environment			: test_env $(DIR_OBJ)
 				@\
-				$(MAKE) $(EXE)
+				$(MAKE) $(OBJECTS_DEPS) $(OBJECTS) $(OBJECTS_BIN)
 
 environment_clean		:
@@ -104,5 +111,6 @@
 				$(ECHO) " -----[ Environment ]------------------------------";\
 				$(ECHO) "";\
-				$(ECHO) " * test_env             : test if environnment's variable is set";\
-				$(ECHO) " * all_environment    : generate object";\
+				$(ECHO) " * exe             : execute testbench";\
+				$(ECHO) " * test_env        : test if environnment's variable is set";\
+				$(ECHO) " * all_environment : generate object";\
 				$(ECHO) "";
Index: /trunk/IPs/systemC/Environment/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/Environment/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/Environment/Makefile.deps	(revision 88)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+
+#-----[ Test ]---------------------------------------------
+
+# Test Environment variables
+ifeq ($(origin MORPHEO_TOPLEVEL), undefined)
+        $(error "variable MORPHEO_TOPLEVEL is undefined");
+else
+        include $(MORPHEO_TOPLEVEL)/Makefile.tools
+endif
+
+#-----[ Variables ]----------------------------------------
+
+ENVIRONMENT_DIR			=	$(MORPHEO_TOPLEVEL)/IPs/systemC/Environment
+ENVIRONMENT_INCDIR		=	-I$(ENVIRONMENT_DIR)/include
+ENVIRONMENT_LIBDIR		=	-L$(ENVIRONMENT_DIR)/lib
+ENVIRONMENT_LIBNAME		=	-lEnvironment -lbfd -liberty 
Index: /trunk/IPs/systemC/Environment/Queue/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/Queue/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/Queue/Makefile	(revision 88)
@@ -1,2 +1,6 @@
+#-----[ Variables ]----------------------------------------
+
+ENTITY                         ?= Queue
+
 #-----[ Rules ]--------------------------------------------
 
@@ -7,4 +11,6 @@
 				@$(MAKE) environment_clean
 
+clean_all			: clean
+
 help				:
 				@$(MAKE) environment_help
Index: /trunk/IPs/systemC/Environment/RamLock/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/RamLock/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/RamLock/Makefile	(revision 88)
@@ -1,2 +1,6 @@
+#-----[ Variables ]----------------------------------------
+
+ENTITY                         ?= RamLock
+
 #-----[ Rules ]--------------------------------------------
 
@@ -7,4 +11,6 @@
 				@$(MAKE) environment_clean
 
+clean_all			: clean
+
 help				:
 				@$(MAKE) environment_help
Index: /trunk/IPs/systemC/Environment/Sim2OS/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/Makefile	(revision 88)
@@ -4,4 +4,6 @@
 
 #-----[ Variable ]-----------------------------------------
+
+ENTITY                         ?= Sim2OS
 
 OBJECTS_DEPS			= $(patsubst $(DIR_ENDIANNESS)/$(DIR_SRC)/%.cpp,$(DIR_ENDIANNESS)/$(DIR_OBJ)/%.o,$(wildcard $(DIR_ENDIANNESS)/$(DIR_SRC)/*.cpp))
@@ -19,4 +21,6 @@
 				$(MAKE) environment_clean
 
+clean_all			: clean
+
 help				:
 				@$(MAKE) environment_help
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_convert_address.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_convert_address.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_convert_address.cpp	(revision 88)
@@ -9,9 +9,9 @@
   void * Sim2OS::convert_address (void * address)
   {
-    void * result = param->segment_table->getAddrAlloc((uint32_t)address);
+    void * result = param->segment_table->getAddrAlloc(static_cast<uint32_t>(reinterpret_cast<uint64_t>(address)));
     
     if (result == NULL)
       {
-	std::cerr << "<" << name << "> address don't match : " << std::hex << (uint32_t)(address) << std::dec << std::endl;
+	std::cerr << "<" << name << "> address don't match : " << std::hex << static_cast<uint32_t>(reinterpret_cast<uint64_t>(address)) << std::dec << std::endl;
 	exit(0);
       }
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_parameter.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_parameter.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_parameter.cpp	(revision 88)
@@ -13,5 +13,5 @@
     {
       if (num_reg == 0)
-	num_service = int2service((int)(val));
+	num_service = int2service(static_cast<int32_t>(reinterpret_cast<int64_t>(val)));
       else
 	arguments[num_reg] = val;
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_clock.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_clock.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_clock.cpp	(revision 88)
@@ -16,6 +16,6 @@
     
     std::cout << "\n\t***** service : clock         *****" << std::endl;
-    std::cout << "\tresult    : " << (unsigned int) result << std::endl;
-    std::cout << "\terrno     : " << (unsigned int) error  << std::endl;
+    std::cout << "\tresult    : " << static_cast<int32_t>(reinterpret_cast<int64_t>(result)) << std::endl;
+    std::cout << "\terrno     : " << error << std::endl;
     
     return      result;
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_close.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_close.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_close.cpp	(revision 88)
@@ -12,5 +12,5 @@
       }
     
-    int    fd     = (int)    arguments[1];
+    int    fd     = static_cast<int>(reinterpret_cast<int64_t>(arguments[1]));
     void * result = (void *) close(fd);
     error         = errno;
@@ -18,5 +18,5 @@
     std::cout << "\n\t***** service : close         *****" << std::endl;
     std::cout << "\tfd        : " << (unsigned int) fd     << std::endl;
-    std::cout << "\tresult    : " << (unsigned int) result << std::endl;
+    std::cout << "\tresult    : " << static_cast<int32_t>(reinterpret_cast<int64_t>(result)) << std::endl;
     std::cout << "\terrno     : " << (unsigned int) error  << std::endl;
     
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_lseek.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_lseek.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_lseek.cpp	(revision 88)
@@ -12,7 +12,7 @@
       }
     
-    int    flides   = (int)    arguments[1];
-    off_t  offset   = (off_t)  arguments[2];
-    int    whence   = (int)    arguments[3];
+    int    flides   = static_cast<int  >(reinterpret_cast<int64_t>(arguments[1]));
+    off_t  offset   = static_cast<off_t>(reinterpret_cast<int64_t>(arguments[2]));
+    int    whence   = static_cast<int  >(reinterpret_cast<int64_t>(arguments[3]));
     void * result   = (void *) lseek(flides,offset,whence);
     error           = errno;
@@ -24,5 +24,5 @@
     std::cout << "\toffset    : " << (unsigned int) offset << std::endl;
     std::cout << "\twhence    : " << (unsigned int) whence << std::endl;
-    std::cout << "\tresult    : " << (unsigned int) result << std::endl;
+    std::cout << "\tresult    : " << static_cast<int32_t>(reinterpret_cast<int64_t>(result)) << std::endl;
     std::cout << "\terrno     : " << (unsigned int) error  << std::endl;
     
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_open.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_open.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_open.cpp	(revision 88)
@@ -13,6 +13,6 @@
     
     const char *pathname = (const char *) convert_address(arguments[1]);
-    int         flags    = (int)          arguments[2];
-    mode_t      mode     = (mode_t)       arguments[3];
+    int         flags    = static_cast<int   >(reinterpret_cast<int64_t>(arguments[2]));
+    mode_t      mode     = static_cast<mode_t>(reinterpret_cast<int64_t>(arguments[3]));
     void *      result   = (void *)       open(pathname,flags,mode);
     error                = errno;
@@ -26,5 +26,5 @@
     std::cout << "\tmode  /10 : " << std::dec << (unsigned int) mode     << std::endl;
     std::cout << "\tmode  /16 : " << std::hex << (unsigned int) mode     << std::endl;
-    std::cout << "\tresult    : " << std::dec << (unsigned int) result   << std::endl;
+    std::cout << "\tresult    : " << static_cast<int32_t>(reinterpret_cast<int64_t>(result)) << std::endl;
     std::cout << "\terrno     : " <<             (unsigned int) error    << std::endl;
     
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_read.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_read.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_read.cpp	(revision 88)
@@ -12,5 +12,5 @@
       }
     
-    int     fd       = (int)     arguments[1];
+    int     fd       = static_cast<int>(reinterpret_cast<int64_t>(arguments[1]));
     void *  buf      = (void *)  convert_address(arguments[2]);
     ssize_t count    = (ssize_t) arguments[3];
@@ -19,8 +19,8 @@
     std::cout << "\n\t***** service : read          *****"        << std::endl;
     std::cout << "\tfd        : " <<             (unsigned int) fd     << std::endl;
-    std::cout << "\tbuf       : " << std::hex << (unsigned int) buf    << std::endl;
+    std::cout << "\tbuf       : " << std::hex << static_cast<int32_t>(reinterpret_cast<int64_t>(buf))    << std::endl;
   //std::cout << "\tbuf       : " << std::dec << (char *)       buf    << std::endl;
     std::cout << "\tcount     : " << std::dec << (unsigned int) count  << std::endl;
-    std::cout << "\tresult    : " <<             (unsigned int) result << std::endl;
+    std::cout << "\tresult    : " << static_cast<int32_t>(reinterpret_cast<int64_t>(result)) << std::endl;
     std::cout << "\terrno     : " <<             (unsigned int) error  << std::endl;
     
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_time.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_time.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_time.cpp	(revision 88)
@@ -17,6 +17,6 @@
     
     std::cout << "\n\t***** service : time          *****" << std::endl;
-    std::cout << "\tt         : " << std::hex << (unsigned int) t                                      << std::endl;
-    std::cout << "\tresult    : " << std::dec << (unsigned int) result << " - " << ctime((time_t *) t) << std::endl;
+    std::cout << "\tt         : " << std::hex << static_cast<int32_t>(reinterpret_cast<int64_t>(t))                                      << std::endl;
+    std::cout << "\tresult    : " << std::dec << static_cast<int32_t>(reinterpret_cast<int64_t>(result)) << " - " << ctime((time_t *) t) << std::endl;
     std::cout << "\terrno     : " <<             (unsigned int) error                                  << std::endl;
     
Index: /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_write.cpp
===================================================================
--- /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_write.cpp	(revision 87)
+++ /trunk/IPs/systemC/Environment/Sim2OS/src/Sim2OS_service_write.cpp	(revision 88)
@@ -12,5 +12,5 @@
       }
   
-    int         fd       = (int)          arguments[1];
+    int         fd       = static_cast<int>(reinterpret_cast<int64_t>(arguments[1]));
     const void *buf      = (const void *) convert_address(arguments[2]);
     ssize_t     count    = (ssize_t)      arguments[3];
@@ -22,8 +22,8 @@
     std::cout << "\n\t***** service : write         *****"        << std::endl;
     std::cout << "\tfd        : " <<             (unsigned int) fd     << std::endl;
-    std::cout << "\tbuf       : " << std::hex << (unsigned int) buf    << std::endl;
+    std::cout << "\tbuf       : " << std::hex << static_cast<int32_t>(reinterpret_cast<int64_t>(buf))    << std::endl;
   //std::cout << "\tbuf       : " << std::dec << (char *)       buf    << std::endl;
     std::cout << "\tcount     : " << std::dec << (unsigned int) count  << std::endl;
-    std::cout << "\tresult    : " <<             (unsigned int) result << std::endl;
+    std::cout << "\tresult    : " << static_cast<int32_t>(reinterpret_cast<int64_t>(result)) << std::endl;
     std::cout << "\terrno     : " <<             (unsigned int) error  << std::endl;
     
Index: /trunk/IPs/systemC/Environment/TTY/Makefile
===================================================================
--- /trunk/IPs/systemC/Environment/TTY/Makefile	(revision 87)
+++ /trunk/IPs/systemC/Environment/TTY/Makefile	(revision 88)
@@ -2,4 +2,6 @@
 
 #-----[ Variable ]-----------------------------------------
+
+ENTITY                         ?= TTY
 
 #OBJECTS_DEPS			=
@@ -16,4 +18,6 @@
 				$(RM) tty_*;
 
+clean_all			: clean
+
 help				:
 				@$(MAKE) environment_help
Index: /trunk/IPs/systemC/Environment/include/Cache_Access.h
===================================================================
--- /trunk/IPs/systemC/Environment/include/Cache_Access.h	(revision 87)
+++ /trunk/IPs/systemC/Environment/include/Cache_Access.h	(revision 88)
@@ -22,6 +22,6 @@
   };
 
-  Cache_Access ireq_type2cache_type (Ticache_type_t ireq_type, bool uncached);
-  Cache_Access dreq_type2cache_type (Tdcache_type_t dreq_type, bool uncached);
+  Cache_Access ireq_type2cache_type (morpheo::Ticache_type_t ireq_type, bool uncached);
+  Cache_Access dreq_type2cache_type (morpheo::Tdcache_type_t dreq_type, bool uncached);
 };
 #endif
